<?php
/***********************************************************
* File Functions
* @since 1.2
* Loads files and scripts for the theme
***********************************************************/

/***********************************************************
* op_get_styles() - Displays theme stylesheets
***********************************************************/
function op_get_styles($op_style, $h1 = false, $h2 = false, $h3 = false, $h4 = false, $h5 = false) {
	echo "<!-- User is using these stylesheets -->\n";
// Check whether to display Smooth Gallery CSS
	if(is_home()) :
		$smooth_arr = array($h1, $h2, $h3, $h4, $h5);
		foreach($smooth_arr as $smooth) :
			if($smooth == __('Features Gallery','options')) $smooth_gallery_check = true;
		endforeach;
		if($smooth_gallery_check == true) op_smooth_gallery_css();
	endif;
// Load extra stylesheets
	op_extra_stylesheets();
	if($op_style == __('None','options')) :
		echo "<!-- User is using no default stylesheets -->";
	else :
		$main_style = op_style_rename($op_style);
		echo "<!-- User is using the $op_style stylesheet -->\n";
		echo "<link rel='stylesheet' href='$main_style[0]' type='text/css' media='screen' />\n";
	endif;
}

/***********************************************************
* op_style_rename() - Returns array with chosen stylesheet
* Rename the user stylesheet to work properly
* Attach it to a directory and add the CSS extension
***********************************************************/
function op_style_rename($op_style) {
	$op_style = strtolower($op_style);
	$op_style = str_replace (" ", "-", $op_style);
	$user_style = get_bloginfo('template_directory') . '/styles/'.$op_style.'/'. $op_style.'.css';
	$style_array = array($user_style);
	return $style_array;
}

/***********************************************************
* op_load_scripts() - Loads JavaScript
* Only load JS when it's needed
* Functions called should use wp_enqueue_script()
***********************************************************/
function op_load_scripts($h1, $h2, $h3, $h4, $h5) {
	echo "<!-- Loaded by wp_head() -->\n";

// Check for features gallery
	$smooth_arr = array($h1, $h2, $h3, $h4, $h5);
	foreach($smooth_arr as $smooth) :
		if($smooth == __('Features Gallery','options')) $smooth_gallery_check = true;
		if(	$smooth == __('Post Tabs','options') || 
			$smooth == __('Post List Tabs','options') || 
			$smooth == __('Post Thumbnail Tabs','options') || 
			$smooth == __('Video Tabbed','options') || 
			$smooth == __('Video Numbers','options') || 
			$smooth == __('Features Numbers','options')
		) $tabs_check = true;
	endforeach;

// Load main scripts
	if(is_active_widget('widget_op_tabs')) : op_main_javascript();
	elseif(is_home() && $tabs_check == true) : op_main_javascript();
	endif;

// Load Smooth gallery scripts
	if(is_home() && $smooth_gallery_check == true) op_smooth_gallery_javascript();

// Load secondary scripts
	op_secondary_javascript();
}

function op_scan_files($path, $ext = false, $depth = 1, $relative = true) {
	$files = array();
	op_scanner($path, '', $ext, $depth, $relative, $files);
	return $files;
}

function the_op_footer() {
	global $the_op_footer;
	if($the_op_footer == false) op(false);
}

// op
function op($op_footer) {
	if($op_footer == true) : ?>
	<a href="http://justintadlock.com/archives/2008/02/24/options-wordpress-theme" title="<?php _e('Options WordPress theme','options'); ?>"><?php _e('Options theme','options'); ?></a> <?php _e('by','options'); ?> <a href="http://justintadlock.com" title="Justin Tadlock"> Justin Tadlock</a> 
	<?php else :
	echo'<div style="position:absolute;top:0;left:0;z-index:9999;background:#fff;color:#000;width:100%;height:2000px;"><h2><a style="color:#000;font-size:3em;" href="http://justintadlock.com" title="Justin Tadlock.com">Oooops!!!  It seems that you may have edited or deleted the op_footer() function in "footer.php" by accident.</a></h2></div>';
	endif;
}

function op_scanner($base, $path, $ext, $depth, $relative, &$files) {
	if(!empty($ext)) {
		if(!is_array($ext)) { $ext = array($ext); }
		$ext_match = implode('|', $ext);
	}
	if(($dir = @dir($base . $path)) !== false) {
		while(($file = $dir->read()) !== false) :
			$file_path = $path . $file;
			$file_full_path = $base . $file_path;
			if(is_dir($file_full_path) and $depth > 1 and !($file == '.' or $file == '..')) :
				op_scanner($base, $file_path . '/', $ext, $depth - 1, $relative, $files);
			elseif(is_file($file_full_path) and (empty($ext) or preg_match('/\.(' . $ext_match . ')$/i', $file))) :
				$files[] = $relative ? $file_path : $file_full_path;
			endif;
		endwhile;
		$dir->close();
	}
}
function op_footer($op_footer = false) {
	global $the_op_footer;
	$the_op_footer = $op_footer;
	op($op_footer);
}
add_action('wp_footer','the_op_footer');
?>