<?php
/********************************************************
Do not modify unless you know what you're doing
********************************************************/

/********************************************************
* Load settings and files for the theme
********************************************************/
// For international users
	load_theme_textdomain('options');

// Include all the app files
	require_all(TEMPLATEPATH . '/app/');

// Make the theme options global
	$op_settings = op_options_theme_settings();
	$op_options_load = $op_settings['options'];
	global $op_options_load;

// mytheme_wp_head
	add_action('admin_menu', 'mytheme_add_admin');

// Add theme version to wp_head()
	add_action('wp_head','op_get_version',0);

/********************************************************
* op_version() - returns the theme version number
********************************************************/
function op_version() {
	$op_version = 'Options Theme Version 1.2';
	return $op_version;
}

/********************************************************
* op_get_version() - echos the theme version number
********************************************************/
function op_get_version() {
	$op_version = op_version();
	echo "<!-- $op_version -->\n";
}

/********************************************************
* mytheme_add_admin() - Adds an administration panel
********************************************************/
function mytheme_add_admin() {
	$op_settings = op_options_theme_settings();
	$themename = $op_settings['theme_name'];
	$shortname = $op_settings['short_name'];
	$options = $op_settings['options'];

	if($_GET['page'] == basename(__FILE__)) {
		if('save' == $_REQUEST['action']) :
			foreach($options as $value) :
				update_option($value['id'], $_REQUEST[$value['id']]);
			endforeach;
			foreach ($options as $value) :
				if(isset($_REQUEST[$value['id']])) : update_option($value['id'], $_REQUEST[$value['id']]);
				else : delete_option($value['id']);
				endif;
			endforeach;
			header("Location: themes.php?page=functions.php&saved=true");
			die;
		elseif('reset' == $_REQUEST['action']) :
			foreach ($options as $value) { delete_option($value['id']); }
			header("Location: themes.php?page=functions.php&reset=true");
			die;
		endif;
	}
	add_theme_page($themename.' '.__('Settings','options'), __('Options Theme Settings','options'), 'edit_themes', basename(__FILE__), 'mytheme_admin');
}

/********************************************************
* require_all() - Requires all files of a specific directory
********************************************************/
function require_all($dir_path, $ignore = false) {
	$dir = @dir($dir_path) or die('Could not open required directory ' . $dir_path);
	while(($file = $dir->read()) !== false) :
		if(is_file($dir_path . $file) and (!$ignore or !in_array($file, $ignore)) and preg_match('/\.php$/i', $file))
		require_once($dir_path . $file);
	endwhile;
	$dir->close();
}

/********************************************************
* Set up contants and/or global variables to be used
* Cleans up theme files
********************************************************/
// Load the theme settings
	global $op_options_load;

// Loop through the array
	foreach($op_options_load as $value) :
		if(get_settings( $value['id'] ) === FALSE) $$value['id'] = $value['std'];
		else $$value['id'] = get_settings( $value['id'] );
	endforeach;

// Set theme settings as global variables
	global
		$op_style,
		$op_home_1,
		$op_home_2,
		$op_home_3,
		$op_home_4,
		$op_home_5,
		$op_feed_links,
		$op_feed_url,
		$op_feed_email,
		$op_sidebar_pos,
		$op_nav,
		$op_search,
		$op_cat_1, $op_cat_2, $op_cat_3, $op_cat_4, $op_cat_5, $op_cat_6, $op_cat_7, $op_cat_8;
?>