<?php get_header(); ?>

<?php breadcrumb(); ?>

<?php if(have_posts()) : while(have_posts()) : the_post(); ?>

	<div class="post">
		<h2 class="post-title">
			<a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>"><?php the_title(); ?></a>
		</h2>

		<p class="byline">
			<?php _e('By ','options'); ?> <?php the_author_posts_link(); ?> &bull; 
			<?php the_time(__('F j, Y','options')); ?> 
			<?php edit_post_link('<span class="edit-post">'.__('[Edit]','options').'</span>', ' ', ''); ?>
		</p>

		<div class="entry">
			<?php
				$video = get_the_video(array('Video'));
				if($video == true) echo $video;
				// else echo get_the_image(array('Feature Image','Full','Medium','Thumbnail'),'full');
			?>

			<?php the_content(); ?>
		</div>

		<div class="post-meta-data">
			<?php wp_link_pages('before=<p>'.__('Pages:','options').'&after=</p>'); ?>
			<p>
				<span class="categories"><?php _e('Categories: ','options'); ?> <?php the_category(', '); ?></span>
				<br />
				<span class="tags"><?php _e('Tags: ','options'); ?> <?php the_tags('', ', ', ''); ?></span>
			</p>
		</div>
	</div>

	<div id="author-box" class="section">
		<h3 class="section-header"><?php _e('About the Author','options'); ?></h3>
		<?php
			$avatar = 'wavatar';
			$author_email = get_the_author_email();
			echo get_avatar($author_email, '96', $avatar);
		?>
		<h4><?php the_author_posts_link(); ?></h4>
		<?php the_author_description(); ?>
	</div>

	<?php op_related_posts(); ?>

	<?php comments_template(); ?>

	<div class="navigation-links section">
		<span class="previous"><?php previous_post_link('&laquo; %link'); ?></span>
		<span class="next"><?php next_post_link(' %link &raquo;'); ?></span>
	</div>

	<?php endwhile; ?>

<?php else: ?>

	<p><?php _e('Sorry, no posts matched your criteria.','options'); ?></p>

<?php endif; ?>

<?php get_footer(); ?>