<?php
/***********************************************************
	Tabs widget
***********************************************************/
function widget_op_tabs($args, $widget_args = 1) {
	extract( $args, EXTR_SKIP );
	if(is_numeric($widget_args)) $widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );
	$options = get_option('widget_op_tabs');
	if(!isset($options[$number])) return;

	$t1 = $options[$number]['t1'];
	$t2 = $options[$number]['t2'];
	$t3 = $options[$number]['t3'];
	$t4 = $options[$number]['t4'];
	if($t1 == __('No Tab','options') && $t2 == __('No Tab','options') && $t3 == __('No Tab','options') && $t4 == __('No Tab','options')) $t1 = __('Latest','options');

	echo "<div class='tabs-block'>\n<div class='tabbed'>\n<ul class='tabs'>";

// Display the tab if an option has been chosen (manually input your custom title and tab name if using 'Custom')
	$tab_arr = array($t1, $t2, $t3, $t4);
	$tab_count = count($tab_arr);
	$i = 0; $j = 1;

	foreach($tab_arr as $tab_item) :
		if($tab_item == __('No Tab','options')) :
		elseif($tab_item == __('Custom 1','options')) :
			echo "<li class='t$j'><a class='t$j tab' title='$tab_item'><span>$tab_item</span></a></li>";
			$set_tabs[] = $tab_item; $j++;
		else :
			echo "<li class='t$j'><a class='t$j tab' title='$tab_item'><span>$tab_item</span></a></li>";
			$set_tabs[] = $tab_item;  $j++;
		endif;
	endforeach;
	echo '</ul>';

// Loop through to display tab content
	$i = 1;
	foreach($set_tabs as $set_t) :
		echo '<div class="t' . $i . ' tab-content">';

// Switch statement to display correct tab content
switch($set_t) {
// Custom tab 1
	case __('Custom 1','options') :
		// Input custom code
		echo '<p>'; _e('Please input your custom code','options'); echo '</p>';
	break;
// Custom tab 2
	case __('Custom 2','options') :
		// Input custom code
		echo '<p>'; _e('Please input your custom code','options'); echo '</p>';
	break;
// Custom tab 3
	case __('Custom 3','options') :
		// Input custom code
		echo '<p>'; _e('Please input your custom code','options'); echo '</p>';
	break;
// Custom tab 4
	case __('Custom 4','options') :
		// Input custom code
		echo '<p>'; _e('Please input your custom code','options'); echo '</p>';
	break;
// Archives list
	case __('Archives','options') :
		echo '<ul class="archives">';
			wp_get_archives('type=monthly&limit=10');
		echo '</ul>';
	break;
// Authors list
	case __('Authors','options') :
		echo '<ul class="authors">';
			wp_list_authors('exclude_admin=0');
		echo '</ul>';
	break;
// Bookmarks list
	case __('Bookmarks','options') :
		echo '<ul class="bookmarks">';
			wp_list_bookmarks('categorize=0&title_li=');
		echo '</ul>';
	break;
// Category list
	case __('Categories','options') :
		echo '<ul class="categories">';
			wp_list_categories('orderby=name&hierarchical=0&title_li=');
		echo '</ul>';
	break;
// Comments
	case __('Comments','options') :
		if(function_exists('get_recent_comments')) :
   			echo '<ul id="get-recent-comments" class="recent-comments">'; get_recent_comments(); echo '</ul>';
		elseif(function_exists('rr_recent_comments')) :
			echo '<ul class="recent-comments">'; echo rr_recent_comments(); echo '</ul>';
		else:
		echo '<p>'; _e('You need a comments plugin to use this option.  Here are some options.','options');
		echo '</p><ul><li><a href="http://wordpress.org/extend/plugins/get-recent-comments" title="';
		_e('Recent comments plugin','options'); echo '">'; _e('Recent Comments','options'); echo '</a></li>';
		echo '<li><a href="http://wordpress.org/extend/plugins/recent-love" title="';
		_e('Recent love plugin','options'); echo '">'; _e('Recent Love','options'); echo '</a></li></ul>';
		endif;
	break;
// Latest posts
	case __('Latest','options') :
		rewind_posts();
		echo '<ul class="latest">';
			wp_get_archives('type=postbypost&limit=10');
		echo '</ul>';
	break;
// Pages list
	case __('Pages','options') :
		echo '<ul class="pages">';
			wp_list_pages('title_li=');
		echo '</ul>';
	break;
// Popular posts
	case __('Popular','options') :
		if(function_exists(akpc_most_popular)) :
			echo '<ul class="popular">';
				akpc_most_popular($limit = '10', $before = '<li>', $after = '</li>');
			echo '</ul>';
		else :
			echo '<p>'; _e("You need a popular posts plugin to use this option.  Here are some options.","options");
			echo '</p><ul><li><a href="http://wordpress.org/extend/plugins/popularity-contest/" title="';
			_e('Popularity Contest plugin','options'); echo '">'; _e('Popularity Contest','options'); echo '</a></li></ul>';
		endif;
	break;
// Random posts
	case __('Random','options') :
		echo '<ul class="random">';
		query_posts("orderby=rand&showposts=10");
		while(have_posts()) : the_post();
			echo '<li><a href="'; the_permalink(); echo '" title="'; the_title(); echo '">'; the_title(); echo '</a></li>';
		endwhile;
		echo '</ul>';
		wp_reset_query();
	break;
// Search form
	case __('Search','options') : ?>
		<form class="search" method="get" id="tabs-searchform" action="<?php bloginfo('home'); ?>">
		<p>
			<input class="search" type="text" name="s" id="tabs-s" tabindex="7" value="<?php _e('Search this site...','options'); ?>" onfocus="if(this.value==this.defaultValue)this.value='';" onblur="if(this.value=='')this.value=this.defaultValue;" />
			<input class="search-submit" name="search-submit" type="submit" id="tabs-search-submit" tabindex="8" value="<?php _e('Go','options'); ?>" />
		</p>
		</form><?php
	break;
// Tag cloud
	case __('Tags','options') :
		echo '<p>';
			wp_tag_cloud('largest=15&smallest=8&order=DESC&orderby=count');
		echo '</p>';
	break;
// No tab
	case __('No Tab','options') : break;
// Default
	default: break;
} // End the switch

// Close the outside div
	echo '</div>';
	$i++;
	endforeach;
	echo "</div>\n</div>";
}

/***********************************************************
	Tabs widget control
***********************************************************/
function widget_op_tabs_control($widget_args) {
	global $wp_registered_widgets;
	static $updated = false;

	if(is_numeric($widget_args)) $widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args($widget_args, array( 'number' => -1 ));
	extract( $widget_args, EXTR_SKIP );

	$options = get_option('widget_op_tabs');
	if(!is_array($options)) $options = array();
	if(!$updated && !empty($_POST['sidebar'])) {
		$sidebar = (string) $_POST['sidebar'];
		$sidebars_widgets = wp_get_sidebars_widgets();
		if(isset($sidebars_widgets[$sidebar]))
			$this_sidebar =& $sidebars_widgets[$sidebar];
		else
			$this_sidebar = array();

		foreach($this_sidebar as $_widget_id) :
			if('widget_op_tabs' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number'])) {
				$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
				unset($options[$widget_number]);
			}
		endforeach;

		foreach((array) $_POST['widget-op-tabs'] as $widget_number => $widget_tabs) :
			$t1 = strip_tags(stripslashes($widget_tabs['t1']));
			$t2 = strip_tags(stripslashes($widget_tabs['t2']));
			$t3 = strip_tags(stripslashes($widget_tabs['t3']));
			$t4 = strip_tags(stripslashes($widget_tabs['t4']));
			$options[$widget_number] = compact('t1','t2','t3','t4');
		endforeach;

		update_option('widget_op_tabs', $options);
		$updated = true;
	}
	if( -1 == $number) :
		$t1 = '';
		$t2 = '';
		$t3 = '';
		$t4 = '';
		$number = '%i%';
	else :
		$t1 = attribute_escape($options[$number]['t1']);
		$t2 = attribute_escape($options[$number]['t2']);
		$t3 = attribute_escape($options[$number]['t3']);
		$t4 = attribute_escape($options[$number]['t4']);
	endif;
// Display tab selections
	$t_each_tab[] = __('No Tab','options');
	$t_each_tab[] = __('Archives','options');
	$t_each_tab[] = __('Authors','options');
	$t_each_tab[] = __('Bookmarks','options');
	$t_each_tab[] = __('Categories','options');
	$t_each_tab[] = __('Comments','options');
	$t_each_tab[] = __('Latest','options');
	$t_each_tab[] = __('Pages','options');
	$t_each_tab[] = __('Popular','options');
	$t_each_tab[] = __('Random','options');
	$t_each_tab[] = __('Search','options');
	$t_each_tab[] = __('Tags','options');
	$t_each_tab[] = __('Custom 1','options');
	$t_each_tab[] = __('Custom 2','options');
	$t_each_tab[] = __('Custom 3','options');
	$t_each_tab[] = __('Custom 4','options');
// Loop through to shorten code
	$i = 1;
	while($i <= 4) :
		switch($i) {
			case 1: $tab = $t1; break;
			case 2: $tab = $t2; break;
			case 3: $tab = $t3; break;
			case 4: $tab = $t4; break;
			default: break;
		}
		echo '<p>'; _e('Tab','options'); echo " $i :";
		echo '<select id="tabs-t'.$i.'-'.$number.'" name="widget-op-tabs['.$number.'][t'.$i.']" class="widefat">';
	// Loop through each tab
		foreach($t_each_tab as $t_tab) :
			echo "<option value='$t_tab' " . ($tab == $t_tab ? "selected='selected'" : '') . ">$t_tab</option>";
		endforeach;
		echo '</select></label></p>';
			$i++;
	endwhile; ?>
	<p>
		<input type="hidden" id="tabs-submit-<?php echo $number; ?>" name="tabs-submit-<?php echo $number; ?>" value="1" />
	</p>
<?php }
/***********************************************************
	Register tabs widget
***********************************************************/
function widget_op_tabs_register() {
// Check for the required API functions
	if(!function_exists('wp_register_sidebar_widget') || !function_exists('wp_register_widget_control')) return;
	if(!$options = get_option('widget_op_tabs')) $options = array();
// Widget settings
	$widget_ops = array('classname' => 'widget_op_tabs', 'description' => __('Tabbed jQuery interface with numerous options.','options'));
	$control_ops = array('width' => 200, 'height' => 350, 'id_base' => 'tabs');
	$name = __('Tabs','options');
	$id = false;
// Multi-widget
	foreach(array_keys($options) as $o) :
		// Old widgets can have null values for some reason
		if(!isset($options[$o]['t1']) || !isset($options[$o]['t2']) || !isset($options[$o]['t3']) || !isset($options[$o]['t4']))
			continue;
		$id = "tabs-$o"; // Never never never translate an id
		wp_register_sidebar_widget($id, $name, 'widget_op_tabs', $widget_ops, array('number' => $o));
		wp_register_widget_control($id, $name, 'widget_op_tabs_control', $control_ops, array('number' => $o));
	endforeach;
// If there are none, we register the widget's existance with a generic template
	if(!$id) {
		wp_register_sidebar_widget('tabs-1', $name, 'widget_op_tabs', $widget_ops, array('number' => -1));
		wp_register_widget_control('tabs-1', $name, 'widget_op_tabs_control', $control_ops, array('number' => -1));
	}	
}
?>